#! /usr/bin/python

# -------------------------------------------------------------------- #
# Projekt               : Patientenverwaltung (pyPAT02)
# K L A S S E           : TAdresse                                                #
# Datei                 : adresse.py
# Angepasst fuer Python : Oktober 2002, Bombei, BICS
# -------------------------------------------------------------------- #
# Version     : 0.1.21                                                 #
# Autor       : S. Spolwig, OSZ-Handel I, 10997 Berlin                 #
#                                                                      #
# Aufgabe     : bildet das selbstndige Objekt Adresse ab.             #
# -------------------------------------------------------------------- #

class  TAdresse:
   """
   /* Klasse  TAdresse
   """

   def __init__(selbst):
        """
   /* init (Erzeugungsoperation)
   /* Auftrag: Adresse initialisieren
   /* vorher : ist erzeugt
   /* nachher: alle Datenfelder sind leer.
        """
        selbst.Strasse = ''
        selbst.Plz     = ''
        selbst.Ort     = ''
        selbst.Telefon = ''

   def SetStrasse (selbst, st):
        """
   /* Auftrag: Attribut schreiben
   /* vorher : Person ist vorhanden.
   /* nachher: Attribut ist gesetzt
        """
        selbst.Strasse = st

   def SetPlz (selbst, p ):
        """
   /* Auftrag: Attribut schreiben
        """
        selbst.Plz = p

   def SetOrt (selbst, o ):
        """
   /* Auftrag: Attribut schreiben
        """
        selbst.Ort = o

   def SetTelefon (selbst, t ):
        """
   /* Auftrag: Attribut schreiben
        """
        selbst.Telefon = t


   def GetStrasse (selbst):
        """
   /* Anfrage: Attribut aus dem Objekt lesen
   /* vorher : Person ist vorhanden.
   /* nachher: Liefert Attributwert
        """
        return    selbst.Strasse


   def GetPlz (selbst):
        """
   /* Anfrage: Attribut aus dem Objekt lesen
        """
        return    selbst.Plz

   def GetOrt (selbst):
        """
   /* Anfrage: Attribut aus dem Objekt lesen
        """
        return       selbst.Ort

   def GetTelefon (selbst):
        """
   /* Anfrage: Attribut aus dem Objekt lesen
        """
        return      selbst.Telefon

   def InDateiSchreiben (selbst, fs):
        """
   /* Parameter fs : Dateiobjekt
   /* Auftrag: Attribute auf die Festplatte speichern
   /* vorher : fs ist geffnet zum Schreiben
   /* nachher: Attribute sind an fs uebergeben
        """
        fs.write       (selbst.Strasse)
        fs.write       (selbst.Plz)
        fs.write       (selbst.Ort)
        fs.write       (selbst.Telefon)


   def AusDateiLesen (selbst, fs) :
        """
   /* Parameter fs : Dateiobjekt
   /* Auftrag: Attribute von der Festplatte laden
   /* vorher : fs ist geffnet zum Lesen
   /* nachher: Attribute sind an "Adresse" uebergeben, liefert "1"
   /* Fehler : liefert "0", wenn Lesefehler, z.B. Dateiende
        """
        try   :
          selbst.Strasse = fs.readline()
          selbst.Plz = fs.readline()
          selbst.Ort = fs.readline()
          selbst.Telefon = fs.readline()
        except: return 0
        else  : return 1

#
#  Testprogramm fr 'adresse.py'
#
if __name__ == '__main__':
   meineAdresse = TAdresse()
   meineDatei   = "Test.txt"
   Datei = open(meineDatei, "w")

   print " Bitte Adressen eingeben: "
   print " Strae: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meineAdresse.SetStrasse(TextZeile)

   print "Postleitzahl: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meineAdresse.SetPlz(TextZeile)

   print "Ort: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meineAdresse.SetOrt(TextZeile)

   print "Telefon: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meineAdresse.SetTelefon(TextZeile)

   meineAdresse.InDateiSchreiben(Datei)

   print "Weiter mit <RETURN>"
   raw_input()

   Datei.close
   
   meineAdresse.__init__()
   print "Alles weg:"
   print meineAdresse.GetStrasse(),
   print meineAdresse.GetPlz(),
   print meineAdresse.GetOrt(),
   print meineAdresse.GetTelefon(),

   Datei = open(meineDatei, "r")

   meineAdresse.AusDateiLesen(Datei)
   print "Wieder da!?"
   print meineAdresse.GetStrasse(),
   print meineAdresse.GetPlz(),
   print meineAdresse.GetOrt(),
   print meineAdresse.GetTelefon(),

   Datei.close


