#!/usr/bin/python

#  --------------------------------------------------------------------
#  Projekt             : Patientenverwaltung (pyPAT02)
#  K L A S S E         : TPatient
#  Datei               : patient.py
#  Angepasst f Python  : Oktober 02, Bombei, BICS
#  --------------------------------------------------------------------
#  Beschreibung: bildet das Objekt Patient ab.
#  Version     : 1.3    (TP und Delphi)
#  Autor       : S. Spolwig, OSZ-Handel I, 10997 Berlin                 
#  ********************************************************************

from person import TPerson

class TPatient(TPerson):
   """
   /* Klasse TPatient erbt von Klasse TPerson
   """

   def __init__ (selbst):
        """
        /* init (Erzeugungsoperation)
        /* Auftrag: Patient initialisieren
        /* vorher : ist erzeugt
        /* nachher: alle Datenfelder sind leer.
        """
        TPerson.__init__(selbst)
        selbst.Geschlecht   = ''
        selbst.Krankenkasse = ''
        selbst.Blutgruppe   = ''

   def SetGeschlecht (selbst, g):
        """
        /* Auftrag: Attribut schreiben
        /* vorher : Person ist vorhanden.
        /* nachher: Attribut ist gesetzt
        """
        selbst.Geschlecht = g

   def SetKrankenkasse (selbst, kk):
        """
        /* Auftrag: Attribut schreiben
        """
        selbst.Krankenkasse = kk

   def SetBlutgruppe (selbst, bg):
        """
        /* Auftrag: Attribut schreiben
        """
        selbst.Blutgruppe = bg

   def GetGeschlecht (selbst):
        """
        /* Auftrag: Attribut aus dem Objekt lesen
        /* vorher : Person ist vorhanden.
        /* nachher: Liefert Attributwert
        """
        return  selbst.Geschlecht

   def  GetKrankenkasse (selbst):
        """
        /* Auftrag: Attribut aus dem Objekt lesen
        """
        return  selbst.Krankenkasse

   def  GetBlutgruppe (selbst):
        """
        /* Auftrag: Attribut aus dem Objekt lesen
        """
        return  selbst.Blutgruppe

   def InDateiSchreiben ( selbst, Fs ) :
        """
        /* Parameter  fs : Dateiobjekt
        /* Auftrag: Attribute auf die Festplatte speichern
        /* vorher : fs ist geffnet zum Schreiben
        /* nachher: Attribute sind an fs uebergeben
        """
        TPerson.InDateiSchreiben(selbst, Fs)
        Fs.write (selbst.Geschlecht)
        Fs.write (selbst.Krankenkasse)
        Fs.write (selbst.Blutgruppe)

   def AusDateiLesen ( selbst, Fs ) :
        """
        /* Parameter  fs : Dateiobjekt
        /* Auftrag: Attribute von der Festplatte laden
        /* vorher : fs ist geffnet zum Lesen
        /* nachher: Attribute sind an "Patient" uebergeben, liefert "1"
        /* Fehler : liefert "0", wenn Lesefehler, z.B. Dateiende
        """
        if TPerson.AusDateiLesen(selbst, Fs) :
         try   :
          selbst.Geschlecht   = Fs.readline()
          selbst.Krankenkasse = Fs.readline()
          selbst.Blutgruppe   = Fs.readline()
         except: return 0
         else  : return 1
        else : return 0


#
#  Testprogramm
#
if __name__ == '__main__':
   meinPatient = TPatient()
   meineDatei   = "TestPat.txt"
   Datei = open(meineDatei, "w")

   print "\nBitte Person eingeben: "
   print " Name: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.SetName(TextZeile)

   print "Vorname: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.SetVorname(TextZeile)

   print "Geburtstag: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.SetGeburtstag(TextZeile)

   print "\nBitte Adressen eingeben: "
   print " Strae: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetStrasse(TextZeile)

   print "Postleitzahl: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetPlz(TextZeile)

   print "Ort: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetOrt(TextZeile)

   print "Telefon: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetTelefon(TextZeile)

   print "\nBitte Patientendaten eingeben: "
   print " Geschlecht (m/w): " ,
   TextZeile = raw_input()
   TextZeile = TextZeile[0] + "\n"
   meinPatient.SetGeschlecht(TextZeile)

   print "Krankenkasse: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.SetKrankenkasse(TextZeile)

   print "Blutgruppe: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinPatient.SetBlutgruppe(TextZeile)

   meinPatient.InDateiSchreiben(Datei)

   print "\nWeiter mit <RETURN>"
   raw_input()

   Datei.close

   meinPatient.__init__()
   print "\nAlles weg:"
   print meinPatient.GetName(),
   print meinPatient.GetVorname(),
   print meinPatient.GetGeburtstag(),
   print meinPatient.Adresse.GetStrasse(),
   print meinPatient.Adresse.GetPlz(),
   print meinPatient.Adresse.GetOrt(),
   print meinPatient.Adresse.GetTelefon(),
   print meinPatient.GetGeschlecht(),
   print meinPatient.GetKrankenkasse(),
   print meinPatient.GetBlutgruppe()

   Datei = open(meineDatei, "r")

   meinPatient.AusDateiLesen(Datei)
   print "\nWieder da!?\n"
   print "N: ", meinPatient.GetName(),
   print "V: ", meinPatient.GetVorname(),
   print "G: ", meinPatient.GetGeburtstag(),
   print "S: ", meinPatient.Adresse.GetStrasse(),
   print "P: ", meinPatient.Adresse.GetPlz(),
   print "O: ", meinPatient.Adresse.GetOrt(),
   print "T: ", meinPatient.Adresse.GetTelefon(),
   print "G: ", meinPatient.GetGeschlecht(),
   print "K: ", meinPatient.GetKrankenkasse(),
   print "B: ", meinPatient.GetBlutgruppe()

   Datei.close

