#! /usr/bin/python

# ******************************************************************** #
# Projekt               : Patientenverwaltung (pyPAT02)
# K L A S S E           : TPerson                                                #
# Datei                 : person.py
#              Neu      : Person aggregiert Adresse!!!
# Angepasst fuer Python : Okt. 2002, Bombei, BICS
# -------------------------------------------------------------------- #
# Autor       : S. Spolwig, OSZ-Handel I, 10997 Berlin                 #
# Aufgabe     : bildet das Objekt Person ab.                           #
# ******************************************************************** #


from adresse import TAdresse

class TPerson :
   """
   /* Klasse TPerson aggregiert Klasse TAdresse
   """

   def __init__ (selbst):
        """
        /* init (Erzeugungsoperator)
        /* Auftrag: Person initialisieren
        /* vorher : ist erzeugt
        /* nachher: alle Datenfelder sind leer.
        """
        selbst.Adresse    = TAdresse()
        selbst.Name       = ''
        selbst.Vorname    = ''
        selbst.Geburtstag = ''

   def SetName (selbst, n):
        """
        /* Auftrag: Attribut schreiben
        /* vorher : Person ist vorhanden.
        /* nachher: Attribut ist gesetzt
        """
        selbst.Name = n

   def SetVorname (selbst, vn):
        """
        /* Auftrag: Attribut schreiben
        """
        selbst.Vorname = vn

   def SetGeburtstag (selbst, gb):
        """
        /* Auftrag: Attribut schreiben
        """
        selbst.Geburtstag = gb

   def  GetName (selbst):
        """
        /* Anfrage: Attribut aus dem Objekt lesen
        /* vorher : Person ist vorhanden.
        /* nachher: Liefert Attributwert
        """
        return  selbst.Name

   def  GetVorname (selbst):
        """
        /* Anfrage: Attribut aus dem Objekt lesen
        """
        return  selbst.Vorname

   def  GetGeburtstag (selbst):
        """
        /* Anfrage: Attribut aus dem Objekt lesen
        """
        return  selbst.Geburtstag

   def InDateiSchreiben ( selbst, Fs ) :
        """
        /* Parameter  fs : Dateiobjekt
        /* Auftrag: Attribute auf die Festplatte speichern
        /* vorher : fs ist geffnet zum Schreiben
        /* nachher: Attribute sind an fs uebergeben
        """
        Fs.write (selbst.Name)
        Fs.write (selbst.Vorname)
        Fs.write (selbst.Geburtstag)
        selbst.Adresse.InDateiSchreiben(Fs)

   def AusDateiLesen ( selbst, Fs ) :
        """
        /* Parameter  fs : Dateiobjekt
        /* Auftrag: Attribute von der Festplatte laden
        /* vorher : fs ist geffnet zum Lesen
        /* nachher: Attribute sind an "Person" uebergeben, liefert "1"
        /* Fehler : liefert "0", wenn Lesefehler, z.B. Dateiende
        """
        try   :
          ersteZeile = Fs.readline()
#          print ersteZeile
          if ersteZeile == "" : return 0
          selbst.Name = ersteZeile
          selbst.Vorname = Fs.readline()
          selbst.Geburtstag = Fs.readline()
        except: return 0
        else  :
          if selbst.Adresse.AusDateiLesen(Fs) :
                 return 1
          else : return 0

#
#  Testprogramm
#
if __name__ == '__main__':
   meinePerson = TPerson()
   meineDatei   = "TestPers.txt"
   Datei = open(meineDatei, "w")

   print "\nBitte Personen eingeben: "
   print " Name: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.SetName(TextZeile)

   print "Vorname: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.SetVorname(TextZeile)

   print "Geburtstag: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.SetGeburtstag(TextZeile)

   print "\nBitte Adressen eingeben: "
   print " Strae: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.Adresse.SetStrasse(TextZeile)

   print "Postleitzahl: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.Adresse.SetPlz(TextZeile)

   print "Ort: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.Adresse.SetOrt(TextZeile)

   print "Telefon: " ,
   TextZeile = raw_input()
   TextZeile = TextZeile + "\n"
   meinePerson.Adresse.SetTelefon(TextZeile)

   meinePerson.InDateiSchreiben(Datei)

   print "\nWeiter mit <RETURN>"
   raw_input()

   Datei.close

   meinePerson.__init__()
   print "\nAlles weg:"
   print meinePerson.GetName(),
   print meinePerson.GetVorname(),
   print meinePerson.GetGeburtstag(),
   print meinePerson.Adresse.GetStrasse(),
   print meinePerson.Adresse.GetPlz(),
   print meinePerson.Adresse.GetOrt(),
   print meinePerson.Adresse.GetTelefon(),

   Datei = open(meineDatei, "r")

   meinePerson.AusDateiLesen(Datei)
   print "\nWieder da!?\n"
   print meinePerson.GetName(),
   print meinePerson.GetVorname(),
   print meinePerson.GetGeburtstag(),
   print meinePerson.Adresse.GetStrasse(),
   print meinePerson.Adresse.GetPlz(),
   print meinePerson.Adresse.GetOrt(),
   print meinePerson.Adresse.GetTelefon(),

   Datei.close

