#!/usr/bin/python

# Projekt               : Patientenverwaltung (pyPAT02)
# K L A S S E           : TPatListe
#                              erbt alles von Klasse TListe
# Datei                 : pliste.py
# Autor                 : Oktober 02, Bombei, BICS

import pickle

from sliste  import TListe
from patient import TPatient

class TPatListe(TListe):
   """
   /*  Listentyp, angepasst fuer Patientenverwaltung,
   /*    erbt alles von Klasse TListe
   """

   def __init__(selbst):
        """
        /* Auftrag : Listenobjekt erzeugen und initialisieren
        /* vorher  : -
        /* nachher : (Siehe TListe und:)
        /*           Standard-Dateiname ist "TestPatient.txt"
        /* Assoziation: Instanz des Patiententypen werden
        /*           weiter unten "bei Bedarf" gebildet:
        /*           PElement = TPatient()
        """
        TListe.__init__(selbst)
        selbst.DatName  = "TestPatient.txt"

   def setze_Dateinamen(selbst, neuName):
        """
        /* Auftrag : Der interne Dateiname wird neu gesetzt
        /* vorher  : -
        /* nachher : Standard-Dateiname ist Inhalt von "neuName"
        """
        selbst.DatName  = neuName

   def gib_Dateinamen(selbst):
        """
        /* Auftrag : Der interne Dateiname wird zurueckgegeben
        /* vorher  : -
        /* nachher : aktueller Dateiname wird zurueckgegeben
        """
        return selbst.DatName

   def laden(selbst) :
        """
        /* Auftrag: Liste aus externer Datei laden.
        /* vorher : Die Liste ist initialisiert,
        /*          Dateiname wurde gesetzt, Datei existiert .
        /* nachher: Die Liste ist in den Arbeitsspeicher geladen;
        /*          Datei ist geschlossen; AktPos ist auf erstem Element;
        /*          Rueckgabewert "1"
        /* Fehler : misslingt das Oeffnen der Datei, geschieht nichts,
        /*          Rueckgabewert "0"
        """
        try :
          Fs = open(selbst.DatName, "r")
        except :
          return 0
        else :
          PElement  = TPatient()
          while PElement.AusDateiLesen(Fs) :
            selbst.Append(PElement)
#            einElement = selbst.GetElement()
#            print "Name: %s " % einElement.GetName()
#            print PElement.GetName()
            PElement  = TPatient()
          Fs.close()
          selbst.First()
          return 1

   def speichern (selbst):
        """
        /* Auftrag: Liste in externe Datei speichern
        /* vorher : Dateiname wurde gesetzt
        /* nachher: Die Liste ist unter "Dateiname" gespeichert.
        /*          Die Datei ist geschlossen. Rueckgabewert "1".
        /* Achtung: Evtl. existierende Dateien werden ueberschrieben!!
        /* Fehler : Misslingt das Oeffnen der Datei, geschieht nichts.
        /*          Ist die Liste leer, wird nichts gespeichert.
        /*          Rueckgabewert "0"
        """
        if not selbst.IsEmpty() :
          try :
            Fs = open(selbst.DatName, "w")
          except :
            return 0
          else :
            selbst.First()
            while not selbst.EoList() :
#              print "Pos.: %d " % selbst.AktuellePos ,
              einElement = selbst.GetElement()
#              print "Name: %s " % einElement.GetName()
              einElement.InDateiSchreiben(Fs)
              selbst.Next()
            Fs.close()
            return 1
        else :
            return 0


#
#  Testprogramm
#
#  die auskommentierten "print"-Anweisungen oben in den Methoden
#  "laden" und "speichern" dienen der Fehleranalyse)
#
if __name__ == '__main__':

 def eingeben (meinPatient, index):
   # erzeugt automatisch einen nummerierten Patientendatensatz
   geschl = ["m","w"]
#   print "\nBitte %d . Person eingeben: " % index
#   print " Name: " ,
#   TextZeile = raw_input()
#   TextZeile = TextZeile + "\n"
   TextZeile = "na" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.SetName(TextZeile)

#   print "Vorname: " ,
   TextZeile = "vna" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.SetVorname(TextZeile)

#   print "Geburtstag: " ,
   TextZeile = "geb" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.SetGeburtstag(TextZeile)

#   print "\nBitte Adressen eingeben: "
#   print " Strae: " ,
   TextZeile = "str" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetStrasse(TextZeile)

#   print "Postleitzahl: " ,
   TextZeile = "plz" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetPlz(TextZeile)

#   print "Ort: " ,
   TextZeile = "ort" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetOrt(TextZeile)

#   print "Telefon: " ,
   TextZeile = "tel" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.Adresse.SetTelefon(TextZeile)

#   print "\nBitte Patientendaten eingeben: "
#   print " Geschlecht (m/w): " ,
   TextZeile = geschl[index%2] + "\n"
   meinPatient.SetGeschlecht(TextZeile)

#   print "Krankenkasse: " ,
   TextZeile = "kr" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.SetKrankenkasse(TextZeile)

#   print "Blutgruppe: " ,
   TextZeile = "bl" + str(index)
   TextZeile = TextZeile + "\n"
   meinPatient.SetBlutgruppe(TextZeile)

 def ausgeben (meinPatient, index) :
   print "Patient-Ausgabe-Nr. %d" % index
   print "N: ", meinPatient.GetName(),
   print "V: ", meinPatient.GetVorname(),
   print "G: ", meinPatient.GetGeburtstag(),
   print "S: ", meinPatient.Adresse.GetStrasse(),
   print "P: ", meinPatient.Adresse.GetPlz(),
   print "O: ", meinPatient.Adresse.GetOrt(),
   print "T: ", meinPatient.Adresse.GetTelefon(),
   print "G: ", meinPatient.GetGeschlecht(),
   print "K: ", meinPatient.GetKrankenkasse(),
   print "B: ", meinPatient.GetBlutgruppe()

# Jetzt gehts los
# derPatient = TPatient()
 meineListe = TPatListe()
 print "\nPatientenliste testen\nDateiname: ", meineListe.gib_Dateinamen()
 genug = 0
 lfdNr = 1
 while not genug :
   derPatient = TPatient()
   eingeben(derPatient, lfdNr)
   meineListe.Append(derPatient)
   print "Automatisch eingegeben wurde:"
   derPatient = meineListe.GetElement()
   ausgeben(derPatient, lfdNr)
   print "\nNoch einer?\nBeenden mit <Q>, weiter mit <RETURN>"
   antwort = raw_input()
   if len(antwort)==0 : antwort = "Weiter"
   genug = (antwort[0]=="Q" or antwort[0]=="q")
   lfdNr = lfdNr + 1

 print "Liste anzeigen"
 meineListe.First()
 while not meineListe.EoList():
   derPatient = meineListe.GetElement()
   ausgeben(derPatient, meineListe.AktuellePos)
   meineListe.Next()


 print "\nDas war-s, jetzt speichern"
 if meineListe.speichern() :
   print "... erfolgreich"
   derPatient.__init__()
   meineListe.__init__()

   print "\nAlles weg:"
   ausgeben (derPatient, meineListe.AktuellePos)

   print "Aus Datei holen ...",
   if not meineListe.laden():
     print "... nicht erfolgreich!"
   else :
#     print  meineListe.Lilaenge
     print "... %d Datenstze, wieder da!?\n" %  meineListe.Lilaenge
     if not meineListe.Lilaenge < 1 :
      meineListe.First()
      lfdNr = 1
      while not meineListe.EoList() :
        einPatient = TPatient()
        einPatient = meineListe.GetElement()
        ausgeben (einPatient, lfdNr)
        lfdNr = lfdNr + 1
        meineListe.Next()
 else : print "... ging schief !?"





